%{?scl:%scl_package rubygem-%{gem_name}}
%{!?scl:%global pkg_name %{name}}

%global gem_name puma

Summary: Puma is a simple, fast, threaded, and highly concurrent HTTP 1.1 server for Ruby/Rack applications
Name: %{?scl_prefix}rubygem-%{gem_name}
Version: 3.3.0
Release: 1%{?dist}
Group: Development/Languages
License: BSD-3-Clause
URL: http://puma.io
Source0: https://rubygems.org/gems/%{gem_name}-%{version}.gem
Requires: %{?scl_prefix}ruby(release)
Requires: %{?scl_prefix}ruby(rubygems) 
Requires: %{?scl_prefix}ruby >= 1.8.7
BuildRequires: %{?scl_prefix}rubygems-devel 
BuildRequires: %{?scl_prefix}ruby-devel 
BuildRequires: openssl-devel                      
Provides: %{?scl_prefix}rubygem(%{gem_name}) = %{version}

%description
Puma is a simple, fast, threaded, and highly concurrent HTTP 1.1 server for
Ruby/Rack applications. Puma is intended for use in both development and
production environments. In order to get the best throughput, it is highly
recommended that you use a  Ruby implementation with real threads like
Rubinius or JRuby.

%package doc
Summary: Documentation for %{name}
Group: Documentation
Requires: %{name} = %{version}-%{release}
BuildArch: noarch

%description doc
Documentation for %{name}

%prep
%{?scl:scl enable %{scl} - << \EOF}
gem unpack %{SOURCE0}
%{?scl:EOF}
%setup -q -D -T -n  %{gem_name}-%{version}

%{?scl:scl enable %{scl} - << \EOF}
gem spec %{SOURCE0} -l --ruby > %{gem_name}.gemspec
%{?scl:EOF}

%build

# Create the gem as gem install only works on a gem file
%{?scl:scl enable %{scl} - << \EOF}
gem build %{gem_name}.gemspec
%{?scl:EOF}

%{?scl:scl enable %{scl} - << \EOF}
%gem_install
%{?scl:EOF}

%install
mkdir -p %{buildroot}%{gem_dir}
cp -pa .%{gem_dir}/* \
        %{buildroot}%{gem_dir}/

mkdir -p %{buildroot}%{gem_extdir_mri}/%{gem_name}
cp -a .%{gem_extdir_mri}/gem.build_complete %{buildroot}%{gem_extdir_mri}/
cp -a .%{gem_extdir_mri}/%{gem_name}/*.so %{buildroot}%{gem_extdir_mri}/%{gem_name}/

mkdir -p %{buildroot}%{_bindir}
cp -a ./%{_bindir}/* %{buildroot}%{_bindir}

# Remove the binary extension sources and build leftovers.
rm -rf %{buildroot}%{gem_instdir}/ext

%files
%dir %{gem_instdir}
%{_bindir}/puma
%{_bindir}/pumactl
%{gem_extdir_mri}
%{gem_instdir}/README.md
%{gem_instdir}/bin
%{gem_instdir}/tools
%{gem_libdir}
%{gem_spec}
%exclude %{gem_cache}

%files doc
%doc %{gem_docdir}
%{gem_instdir}/.*
%{gem_instdir}/*gemspec
%{gem_instdir}/DEPLOYMENT.md
%{gem_instdir}/LICENSE
%{gem_instdir}/History.txt
%{gem_instdir}/Gemfile
%{gem_instdir}/Manifest.txt
%{gem_instdir}/Rakefile
%doc %{gem_instdir}/docs/config.md
%doc %{gem_instdir}/docs/nginx.md
%doc %{gem_instdir}/docs/signals.md
%doc %{gem_instdir}/docs/systemd.md
%doc %{gem_instdir}/tools/jungle/README.md
%doc %{gem_instdir}/tools/jungle/init.d/README.md
%doc %{gem_instdir}/tools/jungle/upstart/README.md

%changelog
* Fri Apr 08 2016 Satoe Imaishi <simaishi@redhat.com> - 3.3.0-1
- Update gem to 3.3.0

* Thu Sep 10 2015 Satoe Imaishi <simaishi@redhat.com> - 2.13.4-2
- Follow ruby packaging guideline to build/install

* Thu Aug 27 2015 Satoe Imaishi <simaishi@redhat.com> - 2.13.4-1
- Build 2.13.4 for rh-ruby22
